package org.act.metaset;

public class Attribute implements Cloneable {
	
	private QName qName = null; 	private String value; 	
	public Attribute(QName qName, String value) {
		this.qName = qName;
		this.value = value;
	}
	
	public Attribute(String qName, String value) {
		this.qName = new QName(qName);
		this.value = value;
	}
	
	public void setNameSpace(String namespace) {
		qName.setNameSpace(namespace);
	}
	
	public String getNameSpace() {
		return qName.getNameSpace();
	}
	
	public void setName(String name) {
		qName.setName(name);
	}
	
	public String getName() {
		return qName.getName();
	}
	
	public void setValue(String value) {
		this.value = value;
	}
	public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o instanceof Attribute) {
      Attribute anotherAttribute = (Attribute) o;
      if ( (value != null&& (anotherAttribute.value != null) )) {         return (
            qName.getName().equals(anotherAttribute.getName())
            && qName.getNameSpace().equals(
            anotherAttribute.getNameSpace())
            && value.equals(anotherAttribute.value));
      }
            else if((value==null&&anotherAttribute.value != null)||(value!=null&&anotherAttribute.value == null)){
        return false;
      }
      else {
        return (qName.getName().equals(anotherAttribute.getName())
                && qName.getNameSpace().equals(
            anotherAttribute.getNameSpace())
                );
      }
    }
    return false;
	}
	
	public Object clone() throws CloneNotSupportedException {
		return super.clone();
	}
	
	public String getValue() {
		return value;
	}
	public String toString() {
		return qName.toString() + "=\"" + normalize(value) + "\"";
	}
	
    private static String normalize (String s) {
        StringBuffer str = new StringBuffer();
        int len = (s != null) ? s.length() : 0;
        for (int i = 0; i < len; i++) {
            char ch = s.charAt(i);
            switch (ch) {
                case '<': {
                    str.append("&lt;");
                    break;
                }
                case '>': {
                    str.append("&gt;");
                    break;
                }
                case '&': {
                    str.append("&amp;");
                    break;
                }
                case '"': {
                    str.append("&quot;");
                    break;
                }
                case NL: {
                    if (i > 0) {
                        char lastChar = str.charAt(str.length() - 1);
                        if (lastChar != CR) {
                            str.append(LS);
                        }
                        else {
                            str.append(NL);
                        }
                    }
                    else {
                        str.append(LS);
                    }
                    break;
                }
                default: {
                    str.append(ch);
                }
            }
        }
        return (str.toString());
    }
    
    public static final char NL = '\n';
    public static final char CR = '\r';
    
    public static final String LS = System.getProperty("line.separator",
        (new Character(NL)).toString());
}
