
package org.act.services.transaction.manager;


import java.sql.SQLException;
import java.util.ArrayList;
import java.util.List;
import java.util.Vector;
import org.act.services.transaction.exception.TxException;
import org.act.services.transaction.information.DBLog;
import org.act.services.transaction.messages.ApplicationMessage;
import org.act.services.transaction.messages.Begin;
import org.act.services.transaction.messages.Begun;
import org.act.services.transaction.messages.CancelInferiors;
import org.act.services.transaction.messages.CancelTransaction;
import org.act.services.transaction.messages.Cancelled;
import org.act.services.transaction.messages.ConfirmTransaction;
import org.act.services.transaction.messages.Confirmed;
import org.act.services.transaction.messages.Context;
import org.act.services.transaction.messages.ContextReply;
import org.act.services.transaction.messages.Enrol;
import org.act.services.transaction.messages.Fault;
import org.act.services.transaction.messages.Hazard;
import org.act.services.transaction.messages.Message;
import org.act.services.transaction.messages.PrepareInferiors;
import org.act.services.transaction.messages.Redirect;
import org.act.services.transaction.messages.RelatedGroup;
import org.act.services.transaction.messages.RequestInferiorStatuses;
import org.act.services.transaction.messages.Resign;
import org.act.services.transaction.messages.Status;
import org.act.services.transaction.messages.TransactionCancelled;
import org.act.services.transaction.messages.TransactionConfirmed;
import org.act.services.transaction.participant.Vote;
import org.act.services.transaction.util.LogCategory;
import org.act.services.transaction.util.MessageUtil;
import org.act.services.transaction.util.Timer;
import org.act.services.transaction.util.TxUri;
import org.act.services.workflow.transaction.SuperiorRecord;
import org.act.services.workflow.transaction.TransactionDB;
public class Decider extends Superior{
	 
    private long startTime = 0;
    
    private long stopTime = 0;
   
    
    private List dbAddrList = null;
    
        SuperiorRecord suprecord=new SuperiorRecord(txId);
    
    
        
    
    
    public Decider()
    {
        super(LogCategory.getCategory("Э"));
        
        dbAddrList = new ArrayList();
    }
    
    public List getDBAddrList()
    {
        return this.dbAddrList;
    }
    
    public void setDBAddrList(List dbAddrList_)
    {
        this.dbAddrList = dbAddrList_;
    }
    
    public String onMessage(String xml)
    {
        Message retMsg = null;
        try
        {
                        Message msg = MessageUtil.parseMessage(xml);
                        switch (msg.getType())
            {
                case Message.TYPE_BEGIN:
                    retMsg = onBegin((Begin)msg);
                    break;
                case Message.TYPE_CANCELLED:
                    retMsg = onCancelled((Cancelled)msg);
                    break;
                case Message.TYPE_CANCEL_TRANSACTION:
                    retMsg = onCancelTransaction((CancelTransaction)msg);
                    break;
                case Message.TYPE_CONFIRMED:
                    retMsg = onConfirmed((Confirmed)msg);
                    
                    break;
                case Message.TYPE_CONFIRM_TRANSACTION:
                    retMsg = onConfirmTransaction((ConfirmTransaction)msg);
                    break;
                case Message.TYPE_CONTEXT_REPLY:
                    retMsg = onContextReply((ContextReply)msg);
                    break;
                case Message.TYPE_ENROL:
                    retMsg = onEnrol((Enrol)msg);
                    break;
                case Message.TYPE_FAULT:
                    retMsg = onFault((Fault)msg);
                    break;
                case Message.TYPE_HAZARD:
                    retMsg = onHazard((Hazard)msg);
                    break;
                case Message.TYPE_PREPARE_INFERIORS:
                    retMsg = onPrepareInferiors((PrepareInferiors)msg);
                    break;
                case Message.TYPE_REDIRECT:
                    retMsg = onRedirect((Redirect)msg);
                    break;
                case Message.TYPE_RESIGN:
                    retMsg = onResign((Resign)msg);
                    break;
                case Message.TYPE_STATUS:
                    retMsg = onStatus((Status)msg);
                    break;
                case Message.TYPE_REQUEST_INFERIOR_STATUSES:
                    retMsg = onRequestInferiorStatuses((RequestInferiorStatuses)
                        msg);
                    break;
                case Message.TYPE_CANCEL_INFERIORS:
                    retMsg = onCancelInferiors((CancelInferiors)msg);
                    break;
                                                                      case Message.TYPE_RELATED_GROUP:
                    retMsg = onError((RelatedGroup)msg);
                    break;
                case Message.TYPE_UNKNOWN:
                default:
                    retMsg = onApplicationMessage((ApplicationMessage)msg);
            }
        }
        catch (Exception e)
        {
                        logger().debug("Decider onMessage Error:" + e.getMessage());
            retMsg = reportFault("Exception: " + e.getMessage());
        }
        return (retMsg == null) ? null : retMsg.toString();
    }
    
    public Message onError(Message msg)
    {
        return reportFault("Decider should not receive such a message:"
                           + msg.getName());
    }
    
    
    
    public Message onBegin(Begin begin)
    {
                boolean atom = begin.getAtom();
                txId = begin.getTransactionId();
        String type = atom ? "ԭ" : "";
        startTime = System.currentTimeMillis();
                Long st=new Long(startTime);
        suprecord.setStarttime(st.toString());
        suprecord.setTxid(txId);
                System.err.println("*************Ŀʼʱ"+startTime+"*****************");
        System.err.println("*************Ŀʼʱ"+Timer.getCNTime()+"*****************");
        logger().debug("[" + Timer.getCNTime() + "]" + type
                       + "" + txId + "ʼ");
                SuperiorContext sc = control.getSuperiorContext();
        if (sc != null)
        {
            return reportFault("Transaction" + txId + "has already begun");
        }
        sc = new SuperiorContext(txId);
        sc.setAtom(atom);
        sc.setTopTransaction(true);
                                                      
                String superAdd=System.getProperty("DeciderAddress");
        
        System.err.print("ЭַϢ"+superAdd);
               String superiorId = TxUri.buildUri(superAdd, txId);
        sc.setSuperiorId(superiorId);
        sc.setSuperiorAddress(superAdd);
        
        suprecord.setDeciderAddr(superAdd);
        control.setSuperiorContext(sc);
                DBLog.logSuperior(sc);
                control.setTxStatus(TxStatus.TX_BEGINNING);
        
        suprecord.setStatus(TxStatus.TX_BEGINNING);
                Begun begun = new Begun(txId);
                Context context = new Context(superAdd, superiorId);
        if (!atom)
        {
            context.setSuperiorType("cohesion");
        }
        RelatedGroup rg = new RelatedGroup(RelatedGroup.RG_BEGUN_CONTEXT);
        rg.addMessage(context);
        rg.addMessage(begun);
        control.setTxStatus(TxStatus.TX_BEGUN);
        rg.setTransactionId(txId);
        return rg;
    }
    
    public Message onCancelTransaction(CancelTransaction ctMsg)
    {
        Message msg = null;
        String error = null;
        String superiorId = ctMsg.getTransactionIdentifier();
        String type = control.getTxType() ? "ԭ" : "";
                boolean reportHazard = ctMsg.getReportHazard();
        int result = TxControl.TX_FAULT;
        try
        {
            logger().debug("" + txId + "ʼȡ");
            long cancel_b=System.currentTimeMillis();
            suprecord.setCanceltime_b(cancel_b);
            
            result = control.cancel(txId);
            
            long cancel_e=System.currentTimeMillis();
            suprecord.setCanceltime_e(cancel_e);
        }
        catch (TxException te)
        {
            error = "Transaction" + txId + "can not be cancelled :" +
                    te.getMessage();
        }
        if (result == TxControl.TX_CANCELLED)
        {
            msg = new TransactionCancelled(txId);
        }
        else if (result == TxControl.TX_FAULT)
        {
            msg = reportFault("Transaction" + txId + "can not confirm");
        }
                stopTime = System.currentTimeMillis();
                Long sot=new Long(stopTime);
        suprecord.setStarttime(sot.toString());
                String time = Timer.computeTime(startTime, stopTime);
        if (error != null)
        {
            logger().debug("[" + Timer.getCNTime() + "]" + type + "" + txId +
                           "ȡʧ," + error);
            logger().debug(type + "" + txId + "ִ쳣ʱ" + time);
            return reportFault(error);
        }
        logger().debug("[" + Timer.getCNTime() + "]" + type + "" + txId +
                       "ȡ");
        logger().debug(type + "" + txId + "ʱ:" + time);
        msg.setTransactionId(txId);
        return msg;
    }
    
    public Message onConfirmTransaction(ConfirmTransaction ctMsg)
    {
        Message msg = null;
        String error = null;
        String superiorId = ctMsg.getTransactionIdentifier();
                boolean reportHazard = ctMsg.getReportHazard();
        String txId = ctMsg.getTransactionIdentifier();
        String type = control.getTxType() ? "ԭ" : "";
        Vector confirmSet = ctMsg.getInferiorIdentifiers();
        suprecord.setStatus(TxStatus.TX_CONFIRMING);
        if (confirmSet != null)
        {
            control.setConfirmSet(confirmSet);
        }
        int result = TxControl.TX_FAULT;
        try
        {
            logger().debug(" " + txId + " ʼύ");
            long conftime_b=System.currentTimeMillis();
            suprecord.setConfirmtime_b(conftime_b);
           
            result = control.confirm(txId);
            
            long conftime_e=System.currentTimeMillis();
            suprecord.setConfirmtime_b(conftime_e);
            
                        dbAddrList = control.getSuperiorContext().getCompansationAddrList();
        }
        catch (TxException te)
        {
            error = "Transaction " + txId + "cannot be confirmed: " +
                    te.getMessage();
        }
                stopTime = System.currentTimeMillis();
                Long sot=new Long(stopTime);
        suprecord.setStarttime(sot.toString());
                String time = Timer.computeTime(startTime, stopTime);
        if (result == TxControl.TX_CONFIRMED)
        {
            msg = new TransactionConfirmed(txId);
            logger().debug("[" + Timer.getCNTime() + "]" + type + "" + txId +
                           "ύ");
            suprecord.setStatus(TxStatus.TX_CONFIRMED);
            suprecord.setResult("ѳɹύ");
                                   
                    }         else if (result == TxControl.TX_CANCELLED)
        {
            msg = new TransactionCancelled(txId);
            logger().debug("[" + Timer.getCNTime() + "]" + type + "" + txId +
                           "ȡ");
            suprecord.setStatus(TxStatus.TX_CANCELLED);
            suprecord.setResult("ȡ");
                                   
                   }         else if (result == TxControl.TX_FAULT)
        {
            msg = reportFault("Transaction" + txId + "cannot confirm");
            logger().debug("[" + Timer.getCNTime() + "]" + type + "" + txId +
                           "confirmִгִ");
            suprecord.setStatus(TxStatus.TX_FAULT);
            suprecord.setResult("쳣");
        }
        if (error != null)
        {
            logger().debug("[" + Timer.getCNTime() + "]" + type + "" + txId +
                           "ύ," + error);
            logger().debug(type + "" + txId + "ִ쳣ʱ" + time);
            return reportFault(error);
        }
        logger().debug(type + "" + txId + "ִɣʱ" + time);
        msg.setTransactionId(txId);
        
               try {
		TransactionDB.superiorRecord2DB(suprecord);
	} catch (SQLException e) {
				e.printStackTrace();
	}
	        return msg;
    }
    
    public long getstartTime()
    {
    return this.startTime;
    }
    
    public long getstopTime()
    {
        return this.stopTime;
    }
    
    public void setstartTime(long startTime_)
    {
        this.startTime = startTime_;
    }
    
    public void setstopTime(long stopTime_)
    {
        this.stopTime = stopTime_;
    }
        public void enrolled(String transactionid)
    {}
    public int prepare(String transactionid)
        throws TxException
    {
        return Vote.VOTE_PREPARED;
    }
    public void confirm(String transactionid)
        throws TxException
    {}
    public void confirm_one_phase(String parm1)
        throws TxException
    {}
    public void cancel(String transactionid)
    {}
    public long getConfirmTime(){
    	return this.control.getConfirmTime();
    }
    public long getPrepareTime() {
		return this.control.getPrepareTime();
	}
	
}
