
package org.act.services.transaction.messages;
import org.act.metaset.*;
import org.act.services.transaction.util.*;


public class Address {
	
    private String protocol = "soap-http-1";
    
    private String address = null;
    
    private String addinfo = null;
    
    
    public Address(String address)
    {
        this.address = address;
    }
    
    
    public void setAddress(String add)
    {
        address = add;
    }
    
    public String getAddress()
    {
        return address;
    }
    
    public Address(XElement el)
    {
        XHashtable h = el.toHashtable();
        Object obj = h.getSingle("/btp:address/btp:binding-name");
        if (obj != null)
        {
            protocol = obj.toString();
        }
        obj = h.getSingle("/btp:address/btp:binding-address");
        if (obj != null)
        {
            address = obj.toString();
        }
        obj = h.getSingle("/btp:address/btp:additional-information");
        if (obj != null)
        {
            addinfo = obj.toString();
        }
    }
    
    public XElement toXml()
    {
        if (address == null)
        {
            return null;
        }
        XElement el = new XElement("btp:address");
        el.addElement(new XElement("btp:binding-name", protocol));
        el.addElement(new XElement("btp:binding-address", address));
        if (addinfo != null)
        {
            el.addElement(new XElement("btp:additional-information", addinfo));
        }
        return el;
    }
            public Metaset toServiceSet(){
    	
    	if (address == null)
        {
            return null;
        }
    	Metaset addr_s=new Metaset("btp:address");
    	    	Metaset biname_s=new Metaset(new QName("btp:binding-name"));
    	 biname_s.setValue(protocol);
    	 addr_s.add(biname_s);
    	     	 Metaset binaddr_s=new Metaset(new QName("btp:binding-address"));
    	 binaddr_s.setValue(address);
    	 addr_s.add(binaddr_s);
    	     	 if (addinfo != null)
         {
                 	 Metaset addInfo_s=new Metaset(new QName("btp:additional-information"));
    	 addInfo_s.setValue(addinfo);
       	 addr_s.add(addInfo_s);
         }
    	return addr_s;
    }
    	public static void main(String[] args) {
		  try
	        {
	            String str = "<btp:address>" +
	                "<btp:binding-name>...carrier binding name...</btp:binding-name>" +
	                "<btp:binding-address>...carrier specific address...</btp:binding-address>" +
	                "<btp:additional-information>...optional additional addressing  information...</btp:additional-information> " +
	                "</btp:address>";
	            XElement x = BTPUtil.changeXElement(str);
	            Address address1 = new Address(x);
	            System.err.println(address1.toXml());
	            Address address2 = new Address("myaddress");
	            System.out.println(address2.toXml());
	        }
	        catch (Exception e)
	        {
	            e.printStackTrace();
	        }
	}
}
