
package org.act.services.transaction.messages;
import org.act.services.transaction.util.*;
import java.util.*;


public class Begun extends Message{
	 
    private Vector decaddr_ = null;
    
    private Vector infaddr_ = null;
    
    private String transactid_;
    
    public Begun(String trid)
    {
        super("btp:begun", Message.TYPE_BEGUN);
        transactid_ = trid;
    }
    
    public Begun(XElement el)
    {
        super(el, Message.TYPE_BEGUN);
        String ns = el.getNamespace();
        ns = (ns == null ? "" : ns + ":");
        XHashtable h = el.toHashtable();
        id_ = el.getAttribute("id");
        decaddr_ = pickAddrSet(h, "/" + name_ + "/" + ns + "decider-address");
        infaddr_ = pickAddrSet(h, "/" + name_ + "/" + ns + "inferior-address");
        transactid_ = pickString(h,
                                 "/" + name_ + "/" + ns +
                                 "transaction-identifier");
    }
    
    public void addDeciderAddress(Address add)
    {
        if (decaddr_ == null)
        {
            decaddr_ = new Vector();
        }
        decaddr_.addElement(add);
    }
    
    public void addInferiorAddress(Address add)
    {
        if (infaddr_ == null)
        {
            infaddr_ = new Vector();
        }
        infaddr_.addElement(add);
    }
    
    public String getTransactionId()
    {
        return transactid_;
    }
    
    public XElement toXml()
    {
        XElement el = new XElement("btp:begun");
        if (id_ != null)
        {
            el.addAttribute("id", id_);
        }
        if (decaddr_ != null)
        {
            for (int i = 0; i < decaddr_.size(); i++)
            {
                XElement a = new XElement("btp:decider-address");
                a.addElement(((Address)decaddr_.elementAt(i)).toXml());
                el.addElement(a);
            }
        }
        if (infaddr_ != null)
        {
            for (int i = 0; i < infaddr_.size(); i++)
            {
                XElement a = new XElement("btp:inferior-address");
                a.addElement(((Address)infaddr_.elementAt(i)).toXml());
                el.addElement(a);
            }
        }
        el.addElement(
            new XElement("btp:transaction-identifier", transactid_));
        addQualifiers(el);
        addTargetAddress(el);
        return el;
    }
    public static void main(String[] args)
    {
        Begun begun1 = new Begun("ide12345ffff23434");
        begun1.addDeciderAddress(new Address("deciderAddress1"));
        System.out.println(begun1.toXml());
    }
	
}
