
package org.act.services.transaction.messages;
import org.act.services.transaction.util.*;


public class Cancel extends Message{
	
	
    private String inferiorIdentifier_ = null;
    
    public Cancel()
    {
        super("btp:cancel", Message.TYPE_CANCEL);
    }
    
    public Cancel(String inferiorID)
    {
        super("btp:cancel", Message.TYPE_CANCEL);
        inferiorIdentifier_ = inferiorID;
    }
    
    public Cancel(XElement el)
    {
        super(el, Message.TYPE_CANCEL);
        XHashtable h = el.toHashtable();
        id_ = el.getAttribute("id");
        Object obj = h.getSingle("/btp:cancel/btp:inferior-identifier");
        if (obj != null)
        {
            inferiorIdentifier_ = obj.toString();
        }
    }
    
    public void setInferiorIdentifier(String uri)
    {
        inferiorIdentifier_ = uri;
    }
    
    public String getInferiorIdentifier()
    {
        return inferiorIdentifier_;
    }
    
    public XElement toXml()
    {
        XElement el = new XElement("btp:cancel");
        if (id_ != null)
        {
            el.addAttribute("id", id_);
        }
        el.addElement(
            new XElement("btp:inferior-identifier", inferiorIdentifier_));
        addQualifiers(el);
        addTargetAddress(el);
        addSenderAddress(el);
        return el;
    }
    public static void main(String args[])
    {
        Cancel obj = new Cancel();
        obj.setInferiorIdentifier("http://www.myaddress.com:8080/inferiorid");
        System.out.println(obj.toString());
        obj = new Cancel(obj.toXml());
        System.out.println(obj.toString());
    }
}
