
package org.act.services.transaction.messages;
import org.act.services.transaction.util.*;

public class Enrolled extends Message{
  
	 private String inferiorIdentifier_ = null;
	    public Enrolled()
	    {
	        super("btp:enrolled", Message.TYPE_ENROLLED);
	    }
	    public Enrolled(XElement el)
	    {
	        super(el, Message.TYPE_ENROLLED);
	        XHashtable h = el.toHashtable();
	        id_ = el.getAttribute("id");
	        Object obj = h.getSingle("/btp:enrolled/btp:inferior-identifier");
	        if (obj != null)
	        {
	            inferiorIdentifier_ = obj.toString();
	        }
	    }
	    public void setInferiorIdentifier(String uri)
	    {
	        inferiorIdentifier_ = uri;
	    }
	    public String getInferiorIdentifier()
	    {
	        return inferiorIdentifier_;
	    }
	    public XElement toXml()
	    {
	        XElement el = new XElement("btp:enrolled");
	        if (id_ != null)
	        {
	            el.addAttribute("id", id_);
	        }
	        el.addElement(
	            new XElement("btp:inferior-identifier", inferiorIdentifier_));
	        addQualifiers(el);
	        addTargetAddress(el);
	        addSenderAddress(el);
	        return el;
	    }
	    public static void main(String args[])
	    {
	        System.out.println("===== Build enrolled");
	        Enrolled obj = new Enrolled();
	        obj.setInferiorIdentifier("http://www.myaddress.com:8080/inferiorid");
	        System.out.println(obj.toString());
	        System.out.println("===== Extract enrolled");
	        obj = new Enrolled(obj.toXml());
	        System.out.println(obj.toString());
	    }
}
