
package org.act.services.transaction.messages;
import org.act.services.transaction.util.*;

public class MinimumInferiorTimeout extends Qualifier{
	  
    private int seconds_ = -1;
    
    public MinimumInferiorTimeout(int seconds)
    {
        super("btpq:minimum-inferior-timeout");
        addElement(new XElement("btpq:minimum-timeout",
                                Integer.toString(seconds)));
        seconds_ = seconds;
    }
    
    public MinimumInferiorTimeout(XElement el)
    {
        super(el);
        XElement tlim = elementAt(0);
        if (tlim != null)
        {
            try
            {
                seconds_ = Integer.parseInt(tlim.getValue());
            }
            catch (NumberFormatException ne)
            {
                seconds_ = -1;
            }
        }
    }
    
    public int getMinimumTimeout()
    {
        return seconds_;
    }
    public static void main(String[] args)
    {
        MinimumInferiorTimeout mit = new MinimumInferiorTimeout(1000);
        mit.setMustBeUnderstood(false);
        mit.setToBePropagated(true);
        System.out.println(mit.toXml());
            }
}
