
package org.act.services.transaction.messages;
import org.act.services.transaction.util.*;


public class SuperiorState extends Message{
	
    private String inferiorIdentifier_ = null;
    
    private String status_ = null;
    
    private boolean responseRequested_ = true;
    
    public SuperiorState()
    {
        super("btp:superior-state", Message.TYPE_SUPERIOR_STATE);
    }
    
    public SuperiorState(XElement el)
    {
        super(el, Message.TYPE_SUPERIOR_STATE);
        XHashtable h = el.toHashtable();
        id_ = el.getAttribute("id");
        Object obj = h.getSingle("/btp:superior-state/btp:inferior-identifier");
        if (obj != null)
        {
            inferiorIdentifier_ = obj.toString();
        }
        obj = h.getSingle("/btp:superior-state/btp:status");
        if (obj != null)
        {
            status_ = obj.toString();
        }
        obj = h.getSingle("/btp:superior-state/btp:response-requested");
        if (obj != null)
        {
            responseRequested_ = !obj.toString().equalsIgnoreCase("false");
        }
    }
    
    public void setInferiorIdentifier(String uri)
    {
        inferiorIdentifier_ = uri;
    }
    
    public String getInferiorIdentifier()
    {
        return inferiorIdentifier_;
    }
    
    public void setStatus(String status)
    {
        status_ = status;
    }
    
    public String getStatus()
    {
        return status_;
    }
    
    public void setResponseRequested(boolean response)
    {
        responseRequested_ = response;
    }
    
    public boolean getResponseRequested()
    {
        return responseRequested_;
    }
    
    public XElement toXml()
    {
        XElement el = new XElement("btp:superior-state");
        if (id_ != null)
        {
            el.addAttribute("id", id_);
        }
        el.addElement(
            new XElement("btp:inferior-identifier", inferiorIdentifier_));
        el.addElement(
            new XElement("btp:status", status_));
        el.addElement(
            new XElement("btp:response-requested",
                         (responseRequested_ ? "true" : "false")));
        addQualifiers(el);
        addTargetAddress(el);
        addSenderAddress(el);
        return el;
    }
    public static void main(String args[])
    {
        System.out.println("===== Build superior-state");
        SuperiorState obj = new SuperiorState();
        obj.setInferiorIdentifier("http://www.myaddress.com:8080/inferiorid");
        obj.setResponseRequested(false);
        obj.setStatus("inaccessible");
        System.out.println(obj.toString());
        System.out.println("===== Extract superior-state");
        obj = new SuperiorState(obj.toXml());
        System.out.println(obj.toString());
                org.act.services.transaction.messages.InferiorState inf =
            new org.act.services.transaction.messages.InferiorState("acitive");
    }
	
}
