
package org.act.services.transaction.participant;


import java.lang.reflect.Method;
import java.util.Vector;
import org.act.services.transaction.manager.Actor;
import org.act.services.transaction.manager.Resource;
import org.act.services.transaction.messages.ApplicationMessage;
import org.act.services.transaction.messages.Cancel;
import org.act.services.transaction.messages.Cancelled;
import org.act.services.transaction.messages.Confirm;
import org.act.services.transaction.messages.ConfirmOnePhase;
import org.act.services.transaction.messages.Confirmed;
import org.act.services.transaction.messages.Context;
import org.act.services.transaction.messages.Enrolled;
import org.act.services.transaction.messages.Fault;
import org.act.services.transaction.messages.Hazard;
import org.act.services.transaction.messages.InferiorState;
import org.act.services.transaction.messages.Message;
import org.act.services.transaction.messages.Prepare;
import org.act.services.transaction.messages.Prepared;
import org.act.services.transaction.messages.Redirect;
import org.act.services.transaction.messages.RelatedGroup;
import org.act.services.transaction.messages.RequestStatus;
import org.act.services.transaction.messages.Resign;
import org.act.services.transaction.messages.Status;
import org.act.services.transaction.messages.SuperiorState;
import org.act.services.transaction.util.TxUri;
import org.act.services.transaction.util.XElement;
import org.apache.log4j.Category;
public abstract class  Inferior extends Actor  implements Resource{
	protected InferiorContext ic = null;
    String txId = null;
    
   
    
       	private Class WsCls=null;
	private Object WsInstance=null;
	    public void SetWsClass(Class cls){
    	WsCls=cls;
    }
    public Class GetWsClass(){
    	return WsCls;
    }
    public Object GetWsInstance()throws Exception{
    	if (WsInstance==null) {
    		WsInstance = WsCls.newInstance();
		}
		return WsInstance;
    }
	private Method method = null;
	public Method getMethod(String methodname) throws SecurityException,NoSuchMethodException {
		
			Class cls = this.GetWsClass();
			method = cls.getMethod(methodname,new Class[]{String.class});
	
		return method;
	}
	    
    protected Inferior(Category logger)
    {
        super(logger);
    }
    
    protected Message onRelatedGroup(RelatedGroup msg)
    {
        if (msg.getSubtype() == RelatedGroup.RG_CONTEXT_APP)
        {
            logger().debug("߽յĵӦóϢ");
        }
        Context context = msg.getContext();
        if (context == null)
        {
            logger().debug("onRelatedGroup: ӦóϢвϢ");
            return reportFault("context is not with application message");
        }
               
        Vector allMessages = msg.getMessages();
        RelatedGroup ret = new RelatedGroup();
                ApplicationMessage appMsg = (ApplicationMessage)
                                    msg.getMessageByType(Message.TYPE_UNKNOWN);
        Message appResponse = null;
        if (appMsg != null)
        {
            appResponse = onApplicationMessage(appMsg);
        }
               ret.addMessage(appResponse);
        ret.setTransactionId(txId);
        return ret;
    }
   
    
    Message onPrepare(Prepare msg)
    {
        String status = Status.STATUS_PREPARING;
        String inferId = msg.getInferiorIdentifier();
                if (ic == null)
        {
            System.err.println(""+inferId+"Ϊ");
            return reportFault("infer[" + inferId +
                               "]hasnot been enrolled or has resigned");
        }
        ic.setStatus(status);
                        int result = Vote.VOTE_FAULT;
        Object obj=null;
        try
        {
                    	try{
         	            	   Method method_t=this.getMethod("prepare");
         	            	   obj=this.GetWsInstance();
         	            	   Object[] par=new Object[]{txId};
         	            	   Integer a=(Integer)method_t.invoke(obj,par);
         	   
         	   result=a.intValue();
            }catch(Exception e){
         	   e.printStackTrace();
            }
        }
        catch (Exception e)
        {
            logger().debug("[" + inferId + "]prepareִг쳣:"
                           + e.getMessage() + "FaultϢ");
            return reportFault("inferior[" + inferId + "]cannot prepare because " +
                               e.getMessage());
        }
        if (result == Vote.VOTE_PREPARED)
        {
            Prepared prepared = new Prepared();
            prepared.setSuperiorIdentifier(ic.getSuperiorId());
            prepared.setInferiorIdentifier(inferId);
            prepared.setTransactionId(txId);
                        status = Status.STATUS_PREPARED;
            ic.setStatus(status);
            logger().debug("[" + inferId
                           + "]prepareִɣPreparedϢ");
            if(obj!=null){
            this.setWsInstance(obj);
            }
            return prepared;
        }
        else if (result == Vote.VOTE_ABORTED)
        {
            Cancelled cancelled = new Cancelled();
            cancelled.setSuperiorIdentifier(ic.getSuperiorId());
            cancelled.setInferiorIdentifier(inferId);
            cancelled.setTransactionId(txId);
            status = Status.STATUS_ABORTED;
            ic.setStatus(status);
            logger().debug("[" + inferId
                           + "]prepareִɣCancelledϢ");
            if(obj!=null){
                this.setWsInstance(obj);
                }
            return cancelled;
        }
        else if (result == Vote.VOTE_RESIGN)
        {
            Resign resign = new Resign();
            resign.setInferiorIdentifier(inferId);
            resign.setResponseRequested(true);
            resign.setSuperiorIdentifier(ic.getSuperiorId());
            resign.setTransactionId(txId);
            logger().debug("[" + inferId
                           + "]prepareִɣResignϢ");
                        status = Status.STATUS_RESIGNING;
            ic.setStatus(status);
            if(obj!=null){
                this.setWsInstance(obj);
                }
            return resign;
        }
        else
        {
            Fault fault = new Fault("WrongState", null, null);
            fault.setSuperiorIdentifier(ic.getSuperiorId());
            fault.setInferiorIdentifier(inferId);
            fault.setTransactionId(txId);
            logger().debug("[" + inferId
                           + "]prepareִг쳣FaultϢ");
            status = Status.STATUS_FAULT;
            ic.setStatus(status);
            if(obj!=null){
                this.setWsInstance(obj);
                }
            return fault;
        }
    }
    
    Message onConfirm(Confirm msg)
    {
         String status = Status.STATUS_CONFIRMING;
        String inferId = msg.getInferiorIdentifier();
                if (ic == null)
        {
            return reportFault("inferior[" + inferId +
                "]has not been enrolled in confirm operation or has resigned");
        }
        ic.setStatus(status);
                Object obj=null;
        try
        {
                                	try{
         	            	   Method method_t=this.getMethod("confirm");
         	            	   obj=this.GetWsInstance();
         	            	   Object[] par=new Object[]{txId};
         	   method_t.invoke(obj,par);
         	 
            }catch(Exception e){
         	   e.printStackTrace();
            }
            Confirmed confirmed = new Confirmed();
            confirmed.setSuperiorIdentifier(ic.getSuperiorId());
            confirmed.setInferiorIdentifier(inferId);
            confirmed.setTransactionId(txId);
            logger().debug("[" + inferId +
                           "]confirmִɣconfirmedϢ");
            status = Status.STATUS_CONFIRMED;
            ic.setStatus(status);
            if(obj!=null){
                this.setWsInstance(obj);
                }
            return confirmed;
        }
        catch (Exception e)
        {
                        Hazard hazard = new Hazard();
            hazard.setSuperiorIdentifier(ic.getSuperiorId());
            hazard.setInferiorIdentifier(inferId);
            hazard.setHazardInfo(e.getMessage());
            hazard.setTransactionId(txId);
            logger().debug("[" + inferId + "]confirmִг쳣"
                           + e.getMessage() + "HazardϢ");
            status = Status.STATUS_FAULT;
            ic.setStatus(status);
            if(obj!=null){
                this.setWsInstance(obj);
                }
            return hazard;
        }
    }
    
    Message onCancel(Cancel msg)
    {
        String status = Status.STATUS_CANCELLING;
        String inferId = msg.getInferiorIdentifier();
        String txId = TxUri.getTransactionIdFromUri(inferId);
                if (ic == null)
        {
            return reportFault("inferior[" + inferId +
                "]has not been enrolled in cancel operation or has resigned");
        }
        ic.setStatus(status);
        Object obj=null;
                try
        {
                                            	try{
         	            	   Method method_t=this.getMethod("cancel");
         	            	   obj=this.GetWsInstance();
         	            	   Object[] par=new Object[]{txId};
         	   method_t.invoke(obj,par);
         	 
            }catch(Exception e){
         	   e.printStackTrace();
            }
            Cancelled cancelled = new Cancelled();
            cancelled.setSuperiorIdentifier(ic.getSuperiorId());
            cancelled.setInferiorIdentifier(inferId);
            cancelled.setTransactionId(txId);
            logger().debug("[" + inferId +
                           "]cancelִɣCancelledϢ");
            status = Status.STATUS_CANCELLED;
            ic.setStatus(status);
            if(obj!=null){
                this.setWsInstance(obj);
                }
            return cancelled;
        }
        catch (Exception e)
        {
                        Hazard hazard = new Hazard();
            hazard.setSuperiorIdentifier(ic.getSuperiorId());
            hazard.setInferiorIdentifier(inferId);
            hazard.setHazardInfo(e.getMessage());
            hazard.setTransactionId(txId);
            logger().debug("[" + inferId + "]cancelִг쳣:"
                           + e.getMessage() + "HazardϢ");
            status = Status.STATUS_FAULT;
            ic.setStatus(status);
            if(obj!=null){
                this.setWsInstance(obj);
                }
            return hazard;
        }
    }
    
    Message onConfirmOnePhase(ConfirmOnePhase msg)
    {
        String status = Status.STATUS_CONFIRMING;
        String inferId = msg.getInferiorIdentifier();
                if (ic == null)
        {
            return reportFault("Inferior[" + inferId +
                "]has not been enrolled in confirm_one_phase operation or has resigned");
        }
        ic.setStatus(status);
        Object obj=null;
                try
        {
                                	try{
         	            	   Method method_t=this.getMethod("confirm_one_phase");
         	            	    obj=this.GetWsInstance();
         	            	   Object[] par=new Object[]{txId};
         	   method_t.invoke(obj,par);
         	 
            }catch(Exception e){
         	   e.printStackTrace();
            }
            Confirmed confirmed = new Confirmed();
            confirmed.setSuperiorIdentifier(ic.getSuperiorId());
            confirmed.setInferiorIdentifier(inferId);
            confirmed.setTransactionId(txId);
                        logger().debug("[" + inferId +
                           "]confirm_one_phaseִɣconfirmedϢ");
            status = Status.STATUS_CONFIRMED;
            ic.setStatus(status);
            if(obj!=null){
                this.setWsInstance(obj);
                }
            return confirmed;
        }
        catch (Exception e)
        {
                        Hazard hazard = new Hazard();
            hazard.setSuperiorIdentifier(ic.getSuperiorId());
            hazard.setInferiorIdentifier(inferId);
            hazard.setHazardInfo(e.getMessage());
            hazard.setTransactionId(txId);
            logger().debug("[" + inferId + "]confirm_one_phaseִг쳣"
                           + e.getMessage() + "HazardϢ");
            status = Status.STATUS_FAULT;
            ic.setStatus(status);
            if(obj!=null){
                this.setWsInstance(obj);
                }
            return hazard;
        }
    }
    
    Message onApplicationMessage(ApplicationMessage appMsg)
    {
        Message appResponse = null;
        String opName = appMsg.getOperationName();
        XElement paramEle = appMsg.getParamElement();
                Class appClass = this.getClass();
        String error = null;
        try
        {
            Method method = appClass.getMethod(opName, new Class[]
                                               {XElement.class});
            XElement result = (XElement)method.invoke(this,
                new Object[]
                {paramEle});
            XElement resEle = new XElement(opName + "Response");
            resEle.addElement(result);
            appResponse = new ApplicationMessage(resEle);
        }
        catch (java.lang.NoSuchMethodException nme)
        {
            error = "No such method : " + opName;
        }
        catch (java.lang.IllegalAccessException le)
        {
            error = "the underlying method is inaccessible:" + le.getMessage();
        }
        catch (java.lang.IllegalArgumentException iae)
        {
            error = "the specified object argument is illegal: " +
                    iae.getMessage();
        }
        catch (java.lang.reflect.InvocationTargetException ite)
        {
            error = "the underlying method throws an exception :" +
                    ite.getMessage();
        }
        catch (Exception e)
        {
            error = e.getMessage();
        }
        finally
        {
                        if (error != null)
            {
                logger().error("÷" + opName + "ʱ쳣" + error);
                ic.setStatus(Status.STATUS_FAULT);
                return reportFault(opName + " error:" + error);
            }
            return appResponse;
        }
    }
    
    Message onRequestStatus(RequestStatus msg)
    {
                String infId = msg.getTargetIdentifier();
        String txId = TxUri.getTransactionIdFromUri(infId);
        String status = Status.STATUS_UNKNOWN;
        if (ic != null)
        {
            status = ic.getStatus();
        }
        Status statusMsg = new Status(status);
        statusMsg.setTransactionId(txId);
        return statusMsg;
    }
    
    Message onSuperiorState(SuperiorState msg)
    {
        InferiorState is = new InferiorState(InferiorState.ACTIVE);
        is.setTransactionId(txId);
        return is;
    }
    
    Message reportFault(String text)
    {
        Fault fault = new Fault("General", null, text);
        fault.setTransactionId(txId);
        return fault;
    }
        Message onRedirect(Redirect msg)
    {
        return reportFault("inferior cannot deal with Redirect Message at now");
    }
    
    Message onEnrolled(Enrolled msg)
    {
        return reportFault("inferior should not receive Enrolled message");
    }
	public void setWsInstance(Object wsInstance) {
		WsInstance = wsInstance;
	}
    
}
