
package org.act.services.transaction.util;

import java.util.*;
import org.act.services.transaction.information.TxSetting;
import org.apache.log4j.*;
public class LogCategory {
	 
    private static String txInformationLog = null;
    
    private static String txMessageLog = null;
    
    private static String defaultLevel = "DEBUG";
    
    private static String defaultOut = "System.err";
    
    private static String defaultLay = "[%d  (%F:%L) %c]:\n %m%n \n";
    private static Map logs = new HashMap();
    
    public static Category getCategory(String application)
    {
        txInformationLog = TxSetting.getInformationLogPath();
        txMessageLog = TxSetting.getMessageLogPath();
        Category cat = (Category)logs.get(application);
        if (cat == null)
        {
            cat = Category.getInstance(application);
            logs.put(application, cat);
        }
        Layout layout = new PatternLayout(defaultLay);
        Appender appender = new ConsoleAppender(layout, defaultOut);
                cat.removeAllAppenders();
        try
        {
            Appender fileAppender = new FileAppender(layout, txInformationLog, true);
            cat.addAppender(fileAppender);
        }
        catch (Exception e)
        {}
        cat.setPriority(Priority.toPriority(defaultLevel));
        return cat;
    }
    
    public static void setLevel(String application, String level)
    {
        Category cat = getCategory(application);
        cat.setPriority(Priority.toPriority(level));
    }
    
    public static void setOutput(String application, String output)
    {
        Category cat = getCategory(application);
        Appender appender = null;
        Layout layout = null;
        if (output != null)
        {
            try
            {
                layout = new PatternLayout(defaultLay);
                appender = new FileAppender(layout, output, true);
            }
            catch (Exception e)
            {
                System.err.println("ʹ" + output +
                                   "¼־Ĭʹÿ̨");
                            }
            cat.removeAllAppenders();
            cat.addAppender(appender);
        }
    }
    public static void main(String[] args)
    {
        LogCategory logCategory1 = new LogCategory();
        Category cat = Category.getInstance("test");
        Layout layout = new PatternLayout(defaultLay);
        Appender appender = new ConsoleAppender(layout, defaultOut);
        cat.addAppender(appender);
        cat.setPriority(Priority.toPriority("FATAL"));
        cat.debug("asfsdgdcvbvn");
    }
}
