package org.act.services.workflow.transaction;
import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.net.MalformedURLException;
import java.net.Socket;
import java.net.URL;
import org.act.services.IAttachment;
import org.act.services.ITransportContext;
import org.act.services.MessageContext;
import org.act.services.pool.IObjectPool;
import org.act.services.protocol.http.HTTPTransportContext;
import org.act.services.protocol.http.HttpRequestMessageContext;
import org.act.services.protocol.http.HttpResponseMessageContext;
import org.act.services.protocol.http.MimeHeaders;
import org.act.services.runtime.IRuntime;
import org.act.services.thread.ThreadPoolRunnable;
import org.act.services.transaction.util.BTPUtil;
import org.act.metaset.*;;
public class TransactionMessageContext extends MessageContext{
    	private String operationName="messages";
		private Metaset params=null;
		private String TxId=null;
		private String BtpMsg=null;
		private String url = null;
		private IRuntime runtime;
	
	
	public TransactionMessageContext(String txid,String btpm,String url,IRuntime runtime)
	{
		this.TxId=txid;
		this.BtpMsg=btpm;
		this.url=url;
		this.runtime=runtime;
		try {
			Metaset response = new Metaset("SOAP-ENV","Envelope");
			response.add(new Attribute(new QName("xmlns","SOAP-ENV"),"http://schemas.xmlsoap.org/soap/envelope/"));
			response.add(new Attribute(new QName("xmlns","xsi"),"http://www.w3.org/2001/XMLSchema-instance"));
			response.add(new Attribute(new QName("xmlns","xsd"),"http://www.w3.org/2001/XMLSchema"));
			response.add(new Attribute(new QName("xmlns","soapenc"),"http://schemas.xmlsoap.org/soap/encoding/"));			
						Metaset header = new Metaset("SOAP-ENV","Header");
						Metaset txid_s=new Metaset("TransactionID");
			txid_s.setValue(TxId);
						Metaset btpm_s=new Metaset("btp:message");
			Metaset msg_s=BTPUtil.toServicesSet(BtpMsg);
			btpm_s.add(msg_s);
						header.add(txid_s);
			header.add(btpm_s);
						response.add(header);
			
            Metaset body = new Metaset("SOAP-ENV","Body");	
			
                        Metaset res = new Metaset(operationName);
			
            			Metaset part = new Metaset(operationName); 
            			part.setValue("HelloWorld!");
						part.add(new Attribute("xsi:type","xsd:string"));
			res.add(part);						body.add(res);
			response.add(body);
			
			this.setResponseServices(response);
			IObjectPool pool = runtime.getObjectPool("transport",IObjectPool.IN_MODE);
						
		}catch(Exception ex){
			ex.printStackTrace();
		}
	}
	
	public static Metaset GetResponse(String txid,String btpm){
		Metaset response = new Metaset("SOAP-ENV","Envelope");
		try {
			
			response.add(new Attribute(new QName("xmlns","SOAP-ENV"),"http://schemas.xmlsoap.org/soap/envelope/"));
			response.add(new Attribute(new QName("xmlns","xsi"),"http://www.w3.org/2001/XMLSchema-instance"));
			response.add(new Attribute(new QName("xmlns","xsd"),"http://www.w3.org/2001/XMLSchema"));
			response.add(new Attribute(new QName("xmlns","soapenc"),"http://schemas.xmlsoap.org/soap/encoding/"));			
						Metaset header = new Metaset("SOAP-ENV","Header");
						Metaset txid_s=new Metaset("TransactionID");
			txid_s.setValue(txid);
						Metaset btpm_s=new Metaset("btp:message");
			Metaset msg_s=BTPUtil.toServicesSet(btpm);
			btpm_s.add(msg_s);
						header.add(txid_s);
			header.add(btpm_s);
						response.add(header);
			
            Metaset body = new Metaset("SOAP-ENV","Body");	
			
                        Metaset res = new Metaset("messages");
			
            			Metaset part = new Metaset("messages"); 
            			part.setValue("HelloWorld!");
						part.add(new Attribute("xsi:type","xsd:string"));
			res.add(part);						body.add(res);
			response.add(body);
			
			
		}catch(Exception ex){
			ex.printStackTrace();
		}return response;
	}
	
}
