
package org.act.services.protocol.http;
import java.io.IOException;
import java.net.Socket;
import org.act.metaset.Metaset;
import org.act.services.ConfigException;
import org.act.services.IConfigurable;
import org.act.services.pool.IObjectPool;
import org.act.services.runtime.Application;
import org.act.services.thread.ObjectOperationException;
import org.act.services.thread.Terminatable;
import org.act.services.thread.ThreadPool;

public class HTTPRequestListener extends Terminatable implements IConfigurable {
    
    public HTTPRequestListener(IObjectPool transportInputPool,
            ThreadPool threadPool) {
        this.transportInputPool = transportInputPool;
        this.threadPool = threadPool;
    }
    private IObjectPool transportInputPool = null;
    private ServerContext serverContext = null;
    private ThreadPool threadPool = null;
    
    protected void process() throws ObjectOperationException {
        if (serverContext.getServer() == null)
            return;
                try {
                        Socket socket = serverContext.getServer().accept();
                                    HTTPRequestProcessor thread = new HTTPRequestProcessor(socket,
                    transportInputPool);
                       if( Application.isDebug()){
            System.out.println("HTTPRequestListener.process()getCurrentThreadCount"+ threadPool.getCurrentThreadCount());
           }
            threadPool.runIt(thread);
          
        } catch (IOException e) {
                        if (serverContext.getServer() == null) {
                setState(STOPPING);
            }
        } catch (Exception e) {
        	if (serverContext.getServer() == null) {
                setState(STOPPING);
            }
        }
    }
    
    protected void start() {
        if( Application.isDebug()){
        HTTP11TransportProtocol.log.info(HTTP11TransportProtocol.sm.getString(
                "org.act.webservices.http.port", "" + serverContext.getPort(),
                "HTTP/1.1"));
        }
    }
    protected void prePorocessStopping() throws ObjectOperationException {
        try {
            serverContext.getServer().close();
            serverContext.setServer(null);
        } catch (IOException e) {
            e.printStackTrace();
        }
    }
    public void config(Metaset config) throws ConfigException {
        Metaset socket = config.filter(".\\socket").car();
        int port = Integer.parseInt(socket.selector(".\\", "port"));
        int acceptCount = Integer.parseInt(socket
                .selector(".\\", "acceptCount"));
        try {
            serverContext = new ServerContext(port, acceptCount);
        } catch (Exception ex) {
            throw new ConfigException(ex);
        }
    }
    public Object adapt(Object obj) {
                return null;
    }
    protected void stop() {
    }
}
