package org.act.services.protocol.http;
import java.awt.event.InputEvent;
import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.net.Socket;
import java.util.logging.Logger;
import org.act.services.ITransportContext;
import org.act.services.pool.IObjectPool;
import org.act.services.runtime.Application;
import org.act.services.runtime.IRuntime;
import org.act.services.thread.ThreadPoolRunnable;

public class HTTPRequestProcessor implements ThreadPoolRunnable {
    private Socket socket = null;
    static Logger log = Logger.getLogger(IRuntime.class.getName());
    private IObjectPool transportRequestPool;
    MimeHeaders mimeheaders =null;
    
    public HTTPRequestProcessor(Socket socket, IObjectPool transportRequestPool) {
        this.socket = socket;
        this.transportRequestPool = transportRequestPool;
    }
    
    public ITransportContext getHTTPTransportContext() {
        
                ITransportContext transContext = null;
        try {
                                  
            try {
                if( Application.isDebug()){
                    System.err.println("ʼȡȣԣԣб...");              
                }
                                InputStream in = socket.getInputStream();
                                                                String line = MimeDataUtil.readLine(in);
                if( Application.isDebug()){
                System.out.println("The head...\n"+line);
                }
              
                                                int start = line.indexOf(HTTPConstants.SP);
                int end = line.indexOf(HTTPConstants.SP, start + 1);
                String method = line.substring(0, start);
                                                                String rawPath = line.substring(start + 2, end);
                String httpVersion = line.substring(end + 1);
                                if (method.equals(HTTPConstants.POST)) {
                    transContext = this.ProcessPOST(in);
                    ((HTTPTransportContext)transContext).setPath(rawPath);
                }
                                else if (method.equals(HTTPConstants.GET)) {
                    transContext = this.ProcessGET(in, rawPath);
                }
                
                                else if (method.equals(HTTPConstants.HEAD)) {
                    transContext = this.ProcessHEAD(in);
                }
                else if(line.equals("HTTP/1.1 200 OK")||line.equals("HTTP/1.0 200 OK")){
                    transContext = this.ProcessResponse(in);
                    ((HTTPTransportContext)transContext).setPath("ABC");
                }
                
                else {
                    throw new UnSupportedHttpEception();
                }
                
               
            } catch (Throwable e) {
                e.printStackTrace();
            }
        } finally {
        }
        return transContext;
    }
    private HTTPTransportContext ProcessResponse(InputStream in) throws IOException   {
        if( Application.isDebug()){
            System.err.println("Now Processing ProcessResponse...Fuction");
       
        }
        MimeHeaders reqHeaders = MimeDataUtil.getMimeHeaders(in);
       
        String[] cl = reqHeaders.getHeader("Content-Length");
       
        
        HttpResponseMessageContext response = new HttpResponseMessageContext();
        response.setOutputStream(socket.getOutputStream());
        response.setMimeHeaders(reqHeaders);
                HTTPTransportContext transportContext = new HTTPTransportContext();
        HTTPTransportContext.HTTPRequestContext reqcontext=new HTTPTransportContext.HTTPRequestContext(
                reqHeaders,in );
        
        transportContext
                .setRequestTransportContext(reqcontext);
        HTTPTransportContext.HTTPResponseContext hTTPResponseContext  =new HTTPTransportContext.HTTPResponseContext(
                response);
        hTTPResponseContext.setSocket(this.socket);
        
        transportContext
                .setResponseTransportContext(hTTPResponseContext);
      
     
        return transportContext;
    }
    
    private HTTPTransportContext ProcessGET(InputStream in, String rawPath) throws IOException {
        if( Application.isDebug()){
        log.info("Now Processing Get...Fuction");
        }
        if (rawPath.endsWith("?wsdl")) {
        	String serviceName = rawPath.substring(0,rawPath.lastIndexOf("?wsdl"));
        	String wsdlLoc = Application.getRuntime().getWSDLLocation(serviceName);
        	if (wsdlLoc!=null) {
        		        		InputStream is = new FileInputStream(wsdlLoc);
        		int length = is.available();
        		byte[] bytes = new byte[length];
        		is.read(bytes);
        		OutputStream os = socket.getOutputStream();
        		os.write(("HTTP/1.1 200 OK\r\n").getBytes());
                os.write(("Content-Type: text/xml;charset=UTF-8\r\n")
                        .getBytes());
                                os.write(("Content-Length: " + length + "\r\n")
                        .getBytes());
                os.write("\r\n".getBytes());
                os.write(bytes);
                os.flush();
                os.close();
        		
        	}
        	return null;
        }else if(rawPath.endsWith("?bpel")){
        	String serviceName = rawPath.substring(0,rawPath.lastIndexOf("?bpel"));
        	String wsdlLoc = Application.getRuntime().getWSDLLocation(serviceName);
        	if (wsdlLoc!=null) {
        		        		InputStream is = new FileInputStream(wsdlLoc);
        		int length = is.available();
        		byte[] bytes = new byte[length];
        		is.read(bytes);
        		OutputStream os = socket.getOutputStream();
        		os.write(("HTTP/1.1 200 OK\r\n").getBytes());
                os.write(("Content-Type: text/xml;charset=UTF-8\r\n")
                        .getBytes());
                                os.write(("Content-Length: " + length + "\r\n")
                        .getBytes());
                os.write("\r\n".getBytes());
                os.write(bytes);
                os.flush();
                os.close();
        		
        	}
        	return null;
        }
        HttpRequestMessageContext request = new HttpRequestMessageContext();
  
        request.setInputStream(in);
        
        HttpResponseMessageContext response = new HttpResponseMessageContext();
        response.setOutputStream(socket.getOutputStream());
        response.setMimeHeaders(null);
                HTTPTransportContext transportContext = new HTTPTransportContext();
        
        transportContext
                .setRequestTransportContext(new HTTPTransportContext.HTTPRequestContext());
        HTTPTransportContext.HTTPResponseContext hTTPResponseContext  =new HTTPTransportContext.HTTPResponseContext(
                response);
        hTTPResponseContext.setSocket(this.socket);
        
        transportContext
                .setResponseTransportContext(hTTPResponseContext);
      
   
        return transportContext;
    }
    
    private HTTPTransportContext ProcessHEAD(InputStream in) {
        if( Application.isDebug()){
        log.info("Now Processing HEAD...Fuction");
        }
        return null;
    }
    
    private HTTPTransportContext ProcessPOST(InputStream in) throws IOException  {
        if( Application.isDebug()){
        log.info("Now Processing ProcessPOST...Fuction");
        }
                        MimeHeaders reqHeaders = MimeDataUtil.getMimeHeaders(in);
       
        String[] cl = reqHeaders.getHeader("Content-Length");
       
        
        HttpResponseMessageContext response = new HttpResponseMessageContext();
        response.setOutputStream(socket.getOutputStream());
        response.setMimeHeaders(reqHeaders);
                HTTPTransportContext transportContext = new HTTPTransportContext();
        HTTPTransportContext.HTTPRequestContext reqcontext=new HTTPTransportContext.HTTPRequestContext(
                reqHeaders,in );
        
        transportContext
                .setRequestTransportContext(reqcontext);
        HTTPTransportContext.HTTPResponseContext hTTPResponseContext  =new HTTPTransportContext.HTTPResponseContext(
                response);
        hTTPResponseContext.setSocket(this.socket);
        
        transportContext
                .setResponseTransportContext(hTTPResponseContext);
      
               return transportContext;
    }
    private HTTPTransportContext ProcessPUT(InputStream in) {
        if( Application.isDebug()){
        log.info("Now Processing PUT...Fuction");
        }
     
              return null;
       
    }
    private HTTPTransportContext ProcessDELETE(InputStream in) {
        if( Application.isDebug()){
        log.info("Now Processing DELETE...Fuction");
        }
        return null;
    }
    private HTTPTransportContext ProcessTRACE(InputStream in) {
        if( Application.isDebug()){
        log.info("Now Processing TRACE...Fuction");
        }
        return null;
    }
    private HTTPTransportContext ProcessCONNECT(InputStream in) {
        if( Application.isDebug()){
        log.info("Now Processing CONNECT...Fuction");
        }
        return null;
    }
    
    public Object[] getInitData() {
        return null;
    }
    
    public void runIt(Object[] thData) {
                ITransportContext transportContext = getHTTPTransportContext();
                synchronized (transportRequestPool) {
            while (transportRequestPool.full()) {
                try {
                    transportRequestPool.wait();
                } catch (InterruptedException e) {
                    e.printStackTrace();
                }
            }
            transportRequestPool.put(transportContext);
            transportRequestPool.notifyAll();
        }
    }
}
