
package org.act.services.protocol.http;
import java.io.IOException;
import java.io.OutputStream;
import org.act.services.IAttachment;
import org.act.services.protocol.http.HTTPTransportContext.HTTPResponseContext;
import org.act.services.thread.ThreadPoolRunnable;

public class HTTPResponseProcessor implements ThreadPoolRunnable {
    private HTTPTransportContext.HTTPResponseContext responseContext;
    public HTTPResponseProcessor(
            HTTPTransportContext.HTTPResponseContext responseContext) {
        this.responseContext = responseContext;
    }
    public Object[] getInitData() {
        return null;
    }
    public void runIt(Object[] thData) {
        writeToClient(responseContext);
    }
    private void writeToClient(HTTPTransportContext.HTTPResponseContext obj) {
        HTTPTransportContext.HTTPResponseContext context = (HTTPTransportContext.HTTPResponseContext) obj;
        if (context.getAttachments() != null) {
            try {
                wirteToClinetWithAttach(context);
               
            } catch (IOException e) {
                                e.printStackTrace();
            }
        } else {
            try {
                writetoClinetWithoutAttach(context);
            } catch (IOException e) {
                                e.printStackTrace();
            }
        }
    }
    
    private void writetoClinetWithoutAttach(HTTPResponseContext context) throws IOException {
        HttpResponseMessageContext response = (HttpResponseMessageContext) context
                .getHttpServletResponse();
                                                        response.setContentType("text/xml;charset=UTF-8");
        byte[] resContent = context.getContent().getAttachment();
        
        org.act.services.protocol.http.MimeHeaders resHeaders = response
                .getMimeHeaders();
        int resStatus = response.getStatus();
        String httpCode = null;
        if (resStatus == 500) {
            httpCode = "500 Internal Server Error";
        } else if (resStatus == 404) {
            httpCode = "404 Not Found";
        } else {
            httpCode = "200 OK";
        }
             
            OutputStream out = response.getOutputStream();
            out.write(("HTTP/1.1 " + httpCode + "\r\n").getBytes());
            out.write(("Content-Type: " + response.getContentType() + "\r\n")
                    .getBytes());
                        out.write(("Content-Length: " + (resContent.length) + "\r\n")
                    .getBytes());
            out.write("\r\n".getBytes());
            out.write(resContent);
            out.flush();
            out.close();
                        context.getSocket().close();
       
    }
    
    private void wirteToClinetWithAttach(
            HTTPTransportContext.HTTPResponseContext context)
            throws IOException {
        IAttachment[] attach = context.getAttachments();
        
        String separator = "----" + "ThisisSeaprator"
                + System.currentTimeMillis();
        HttpResponseMessageContext response = (HttpResponseMessageContext) context
                .getHttpServletResponse();
        response.setContentType("multipart/related; " +"boundary="+"\""+separator+"\";"+"type=\"text/xml\"");
        int resStatus = response.getStatus();
        String httpCode = null;
        if (resStatus == 500) {
            httpCode = "500 Internal Server Error";
        } else if (resStatus == 404) {
            httpCode = "404 Not Found";
        } else {
            httpCode = "200 OK";
        }
        OutputStream out = null;
        try {
            out = context.getOutputStream();
        } catch (IOException e) {
                        e.printStackTrace();
        }
        MimePartOutputStream output = new MimePartOutputStream(out, separator);
        int length = 0;
        length = output.getPartOutPutLength(context.getContent(),separator) + length;
        for (int i = 0; i < attach.length; i++) {
            length = length + output.getPartOutPutLength(attach[i], separator);
        }
        
        length = output.getCloseTagLength(separator) + length;
        out.write(("HTTP/1.1 " + httpCode + "\r\n").getBytes());
        out.write(("Content-Type: " + response.getContentType() + "\r\n")
                .getBytes());
                out.write(("Content-Length: " + length + "\r\n").getBytes());
        out.write(("User-Agent: "+"Xservices 1.0"+ "\r\n").getBytes());
        out.write("\r\n".getBytes());
        output.writePart(context.getContent());
        for (int j = 0; j < attach.length; j++) {
            output.writePart(attach[j]);
        }
        output.writeCloseTag();
        out.flush();
        out.close();
                context.getSocket().close();
    }
}
