
package org.act.services.protocol.http;
import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.io.InputStream;
import org.act.services.runtime.Application;

public final class MimeDataUtil {
	
	
	public static byte[] readRawLine(InputStream inputStream)
			throws IOException {
				ByteArrayOutputStream buf = new ByteArrayOutputStream();
		int ch;
		while ((ch = inputStream.read()) >= 0) {
			buf.write(ch);
			if (ch == '\n') {
				break;
			}
		}
		if (buf.size() == 0) {
			return null;
		}
		return buf.toByteArray();
	}
    public static String readLine(InputStream inputStream) throws IOException {
		byte[] rawdata = readRawLine(inputStream);
		if (rawdata == null) {
			return null;
		}
		int len = rawdata.length;
		int offset = 0;
		if (len > 0) {
			if (rawdata[len - 1] == '\n') {
				offset++;
				if (len > 1) {
					if (rawdata[len - 2] == '\r') {
						offset++;
					}
				}
			}
		}
        if (offset == 1) {
            offset=0;
         }
		byte[] realdata = new byte[len - offset];
		System.arraycopy(rawdata, 0, realdata, 0, len - offset);
		return new String(realdata);
	}
    
    public static MimeHeaders getMimeHeaders(InputStream is) throws IOException {
       
        MimeHeaders headers = new MimeHeaders();
        String name = null;
        StringBuffer value = null;
        for (; ;) {
            String line = readLine(is);
            if ((line == null) || (line.length() < 1)) {
                break;
            }
                                                            if ((line.charAt(0) == ' ') || (line.charAt(0) == '\t')) {
                                                if (value != null) {
                    value.append(' ');
                    value.append(line.trim());
                }
            } else {
                                if (name != null) {
                    headers.addHeader(name,value.toString());
                    if(Application.isDebug()){
                    System.out.println(name+":"+value.toString());
                    }
                }
                                                int colon = line.indexOf(":");
                if (colon < 0) {
                    try {
                        throw new HttpException("Unable to parse header: " + line);
                    } catch (HttpException e) {
                                                e.printStackTrace();
                        break;
                    }
                }
                name = line.substring(0, colon).trim();
                value = new StringBuffer(line.substring(colon + 1).trim());
            }
        }
                if (name != null) {
            headers.addHeader(name,value.toString());
            if(Application.isDebug()){
            System.out.println(name+":"+value.toString());
            }
        }
        
        return headers;    
    }
    
}
