
package org.act.services.protocol.http;


import java.util.Iterator;
import java.util.Vector;

public class MimeHeaders {
    
    class MatchingIterator implements Iterator {
        
        private Object nextMatch() {
            label0: while (iterator.hasNext()) {
                MimeHeader mimeheader = (MimeHeader) iterator.next();
                if (names == null) {
                    return match ? null : mimeheader;
                }
                for (int i = 0; i < names.length; i++) {
                    if (!mimeheader.getName().equalsIgnoreCase(names[i])) {
                        continue;
                    }
                    if (match) {
                        return mimeheader;
                    }
                    continue label0;
                }
                if (!match) {
                    return mimeheader;
                }
            }
            return null;
        }
        
        public boolean hasNext() {
            if (nextHeader == null) {
                nextHeader = nextMatch();
            }
            return nextHeader != null;
        }
        
        public Object next() {
            if (nextHeader != null) {
                Object obj = nextHeader;
                nextHeader = null;
                return obj;
            }
            if (hasNext()) {
                return nextHeader;
            } else {
                return null;
            }
        }
        
        public void remove() {
            iterator.remove();
        }
        
        private boolean match;
        
        private Iterator iterator;
        
        private String names[];
        
        private Object nextHeader;
        
        MatchingIterator(String as[], boolean flag) {
            match = flag;
            names = as;
            iterator = headers.iterator();
        }
    }
    
    public MimeHeaders() {
        headers = new Vector();
    }
    
    public String[] getHeader(String name) {
        Vector vector = new Vector();
        for (int i = 0; i < headers.size(); i++) {
            MimeHeader mimeheader = (MimeHeader) headers.elementAt(i);
            if (mimeheader.getName().equalsIgnoreCase(name)
                    && (mimeheader.getValue() != null)) {
                vector.addElement(mimeheader.getValue());
            }
        }
        if (vector.size() == 0) {
            return null;
        } else {
            String as[] = new String[vector.size()];
            vector.copyInto(as);
            return as;
        }
    }
    
    public void setHeader(String name, String value) {
        boolean flag = false;
        if ((name == null) || name.equals("")) {
            throw new IllegalArgumentException("Illegal MimeHeader name");
        }
        for (int i = 0; i < headers.size(); i++) {
            MimeHeader mimeheader = (MimeHeader) headers.elementAt(i);
            if (mimeheader.getName().equalsIgnoreCase(name)) {
                if (!flag) {
                    headers.setElementAt(new MimeHeader(mimeheader.getName(),
                            value), i);
                    flag = true;
                } else {
                    headers.removeElementAt(i--);
                }
            }
        }
        if (!flag) {
            addHeader(name, value);
        }
    }
    
    public void addHeader(String name, String value) {
        if ((name == null) || name.equals("")) {
            throw new IllegalArgumentException("Illegal MimeHeader name");
        }
        int i = headers.size();
        for (int j = i - 1; j >= 0; j--) {
            MimeHeader mimeheader = (MimeHeader) headers.elementAt(j);
            if (mimeheader.getName().equalsIgnoreCase(name)) {
                headers.insertElementAt(new MimeHeader(name, value), j + 1);
                return;
            }
        }
        headers.addElement(new MimeHeader(name, value));
    }
    
    public void removeHeader(String name) {
        for (int i = 0; i < headers.size(); i++) {
            MimeHeader mimeheader = (MimeHeader) headers.elementAt(i);
            if (mimeheader.getName().equalsIgnoreCase(name)) {
                headers.removeElementAt(i--);
            }
        }
    }
    
    public void removeAllHeaders() {
        headers.removeAllElements();
    }
    
    public Iterator getAllHeaders() {
        return headers.iterator();
    }
    
    public Iterator getMatchingHeaders(String names[]) {
        return new MatchingIterator(names, true);
    }
    
    public Iterator getNonMatchingHeaders(String names[]) {
        return new MatchingIterator(names, false);
    }
    
    private Vector headers;
}
