
package org.act.services.protocol.http;
import java.io.ByteArrayOutputStream;
import java.io.FilterInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.util.LinkedList;
import java.util.List;
import org.act.services.AttachmentImpl;
import org.act.services.IAttachment;
import org.act.services.runtime.Application;

public class MimePartInputStream extends FilterInputStream {
    InputStream in = null;
    int pos;
    String bounderyStr = null;
    
    private boolean isCRLF=false;
    
    private boolean eof = false;
    
    private boolean closed = false;
    public final static int BODY_SEPARATOR = 1;
    public final static int END_SEPARATOR = 2;
    public final static int NOT_SEPARATOR_STATE = 0;
    
    public MimePartInputStream(InputStream in, String bounderyStr) {
        super(in);
        if (in == null) {
            throw new IllegalArgumentException(
                    "InputStream parameter may not be null");
        }
        this.bounderyStr = bounderyStr;
        this.in = in;
        this.pos = 0;
    }
    
    public static byte[] readRawLine(InputStream inputStream)
            throws IOException {
                ByteArrayOutputStream buf = new ByteArrayOutputStream();
        int ch;
        while ((ch = inputStream.read()) >= 0) {
            buf.write(ch);
            if (ch == '\n') {
                break;
            }
        }
        if (buf.size() == 0) {
            return null;
        }
        return buf.toByteArray();
    }
 
    public List readPart( ) throws IOException {
        List list = new LinkedList();
                int flagI = this.readSeperator(in);
        if(flagI==NOT_SEPARATOR_STATE){
            try {
                throw new  MimeParse_Exception("Not the Seprator");
            } catch (MimeParse_Exception e) {
                                e.printStackTrace();
            }
        }
        while (flagI == BODY_SEPARATOR) {
                        AttachmentImpl attachment = new AttachmentImpl();
            MimeHeaders mimeHeads = this.readMimeHeads(in);
            attachment.setMimeHeaders(mimeHeads);            byte[] content = new byte[0];
            byte[] part = null;
            flagI = NOT_SEPARATOR_STATE;
            while (flagI == NOT_SEPARATOR_STATE) {
                part = readLine(in);
                if (part == null) {
                                        break;
                }
                if(Application.isDebug()){
                System.out.println(new String(part));
                }
                flagI = NOT_SEPARATOR_STATE;
                if ((part.length == (bounderyStr.length() + 2))
                        || (part.length == (bounderyStr.length() + 4))) {
                                        String str = new String(part);
                    if (str != null) {                        if (str.equals("--" + bounderyStr)) {
                                                        flagI = BODY_SEPARATOR;
                        } else if (str.equals("--" + bounderyStr + "--")) {
                            flagI = END_SEPARATOR;
                                                        eof = true;
                                                    } else {
                                                        flagI = NOT_SEPARATOR_STATE;
                        }
                    }                } else {
                    flagI =NOT_SEPARATOR_STATE;
                }               
                switch (flagI) {
                case BODY_SEPARATOR:
                   
                case END_SEPARATOR:
                    int length1 = (content.length)-2;
                    byte[] temp1 = new byte[length1];
                    if(Application.isDebug()){
                    System.out.println("partlength="+length1);
                    }
                    System.arraycopy(content, 0, temp1, 0, length1);
                    content=temp1;
                    break;
                case NOT_SEPARATOR_STATE: 
                                        if(this.isCRLF==false){
                    int length = (content.length) + (part.length);
                    byte[] temp = new byte[length];
                    System.arraycopy(content, 0, temp, 0, content.length);
                    System
                            .arraycopy(part, 0, temp, content.length,
                                    part.length);
                                        content = temp;   
                    }else{
                        int length = (content.length) + (part.length)+2;
                        byte[] temp = new byte[length];
                        System.arraycopy(content, 0, temp, 0, content.length);
                        System
                                .arraycopy(part, 0, temp, content.length,
                                        part.length);
                        System.arraycopy("\r\n".getBytes(),0,temp,length-2,2);
                        
                                                content = temp;    
                    }
                    break;
                }
                
                
                part = null;
            }            
       
            attachment.setAttachment(content);
                        list.add(attachment);
        }
        return list;
    }
    public MimeHeaders readMimeHeads( InputStream input)
            throws IOException {
        MimeHeaders mimeHeaders = null;
        mimeHeaders = MimeDataUtil.getMimeHeaders(input);
        return mimeHeaders;
    }
    
    public int readSeperator(InputStream inputStream) throws IOException {
        int flag = NOT_SEPARATOR_STATE;
        
        byte[] strbyte = readLine(inputStream);
        if(strbyte==null){
           return  flag;
        }
        String str = new String(strbyte);
        if(Application.isDebug()){
        System.out.println(str);
        }
        if (str != null) {
            if (str.equals("--" + bounderyStr)) {
                flag = BODY_SEPARATOR;
            } else if (str.equals("--" + bounderyStr + "--")) {
                flag = END_SEPARATOR;
                                eof = true;
            }
        }
        return flag;
    }
    
    public  byte[] readLine(InputStream inputStream) throws IOException {
        this.isCRLF=false;
        byte[] rawdata = readRawLine(inputStream);
        if (rawdata == null) {
            return null;
        }
        int len = rawdata.length;
        int offset = 0;
        if (len > 0) {
            if (rawdata[len - 1] == '\n') {
                offset++;
                if (len > 1) {
                    if (rawdata[len - 2] == '\r') {
                        offset++;
                                           }
                }
            }
        }
        if (offset == 1) {
           offset=0;
                 }
        if(offset==2){
               this.isCRLF=true;
        }
        byte[] realdata = new byte[len - offset];
        System.arraycopy(rawdata, 0, realdata, 0, len - offset);
        return realdata;
    }
    
    private void readCRLF() throws IOException {
        int cr = in.read();
        int lf = in.read();
        if ((cr != '\r') || (lf != '\n')) {
            throw new IOException("CRLF expected at end of MimePart: " + cr
                    + "/" + lf);
        }
    }
}
