
package org.act.services.protocol.http;
import java.io.IOException;
import java.net.InetAddress;
import java.net.ServerSocket;
import java.net.UnknownHostException;

public class ServerContext {
            
    private InetAddress bindAddress;
            
    private ServerSocket server = null;
    public ServerContext() throws UnknownHostException {
        this(8080, 50);
    }
    public ServerContext(int port, int requestQueueLength) {
        try {
            server = new ServerSocket(port, requestQueueLength);
        } catch (IOException e) {
            e.printStackTrace();
        }
    }
    public ServerContext(int port, int requestQueueLength,
            InetAddress bindAddress) {
        try {
            server = new ServerSocket(port, requestQueueLength, bindAddress);
        } catch (IOException e) {
            e.printStackTrace();
        }
    }
    
    public int getPort() {
        return server.getLocalPort();
    }
                            
    public ServerSocket getServer() {
        return server;
    }
    
    public void setServer(ServerSocket server) {
        this.server = server;
    }
}
