
package org.act.services.workflow.activity.basic;
import java.util.Stack;
import org.act.metaset.QName;
import org.act.metaset.Metaset;
import org.act.services.IMessageContext;
import org.act.services.MessageContext;
import org.act.services.pool.IObjectPool;
import org.act.services.runtime.IRuntime;
import org.act.services.workflow.activity.ActivityImpl;
import org.act.services.workflow.context.WorkflowRuntimeContext;
import org.act.services.transaction.messages.*;

public class InvokeImpl extends ActivityImpl {
	private IObjectPool msgIn;
	private IRuntime runtime;
												public void process() {
				super.process();
		this.startProcess();
		String partnerLink = activity.selector(".\\", "partnerLink");
		String portType = activity.selector(".\\", "portType");
		String operation = activity.selector(".\\", "operation");
		String inputVariable = activity.selector(".\\", "inputVariable");
		String outputVariable = activity.selector(".\\", "outputVariable");
		Metaset mCorrelations = activity.filter(".\\correlations\\*");
		System.out.println("partnerLink: " + partnerLink + "  portType: "
				+ portType);
		System.out.println("operation: " + operation + "  inputVariable: "
				+ inputVariable + "  outputVariable: " + outputVariable);
		if (mCorrelations != null) {
			for (int i = 0; i < mCorrelations.getChilds().size(); i++) {
				Metaset mCorrelationSet = (Metaset) mCorrelations.getChilds()
						.get(i);
				String set = mCorrelationSet.selector(".\\", "set");
				String initiate = mCorrelationSet.selector(".\\", "initiate");
				String pattern = mCorrelationSet.selector(".\\", "pattern");
				System.out.println("correlation  set: " + set + "  initiate: "
						+ initiate + "  pattern: " + pattern);
			}
		}
		if (outputVariable == null) {
						this.invokeAsyn(partnerLink, portType, operation, inputVariable,
					mCorrelations);
		} else {
						this.invokeSync(partnerLink, portType, operation, inputVariable,
					outputVariable, mCorrelations);
		}
		this.endProcess();
	}
	
	public void invokeAsyn(String partnerLink, String portType,
			String operation, String inputVariable, Metaset mCorrelations) {
		String url = this.getURL(partnerLink);
		Metaset mTranContext = this.getTranContext();
		Metaset csOut = this.getCSOut(inputVariable, mCorrelations);
		Metaset mInputVariable = this.rc.getVariables().getVar(inputVariable);
		new MessageContext(operation, mInputVariable,
				csOut, url, this.runtime, mTranContext);
		log.info(sm.getString("org.act.wswf.activity.invoke.send", url,
				operation));
		this.receive(csOut, partnerLink, portType, operation);
	}
	
	public void invokeSync(String partnerLink, String portType,
			String operation, String inputVariable, String outputVariable,
			Metaset mCorrelations) {
		String url = this.getURL(partnerLink);
		Metaset mTranContext = this.getTranContext();
		Metaset mInputVariable = this.rc.getVariables().getVar(inputVariable);
		Metaset csOut = this.getCSOut(inputVariable, mCorrelations);
		Metaset csNeed = this.getCSNeed(mCorrelations);
		new MessageContext(operation, mInputVariable,
				csOut, url, this.runtime, mTranContext);
		log.info(sm.getString("org.act.wswf.activity.invoke.send", url,
				operation));
		Metaset result = this.receive(csNeed, partnerLink, portType, operation)
				.filter(".\\Body\\*").car();
		this.doResult(result, outputVariable, mCorrelations);
	}
	
	private Metaset getCSOut(String inputVariable, Metaset mCorrelations) {
		Metaset csOut = new Metaset("CorrelationSets");
		if (mCorrelations != null) {
			for (int i = 0; i < mCorrelations.getChilds().size(); i++) {
				Metaset mCorrelationSet = (Metaset) mCorrelations.getChilds()
						.get(i);
				String set = mCorrelationSet.selector(".\\", "set");
				String initiate = mCorrelationSet.selector(".\\", "initiate");
				String pattern = mCorrelationSet.selector(".\\", "pattern");
				if (pattern.equals("out") || pattern.equals("out-in")) {
					if (initiate != null && initiate.equals("yes")) {
						this.rc.getCorrelationSets().setCorrelationSetFromVar(
								set, inputVariable);
						Metaset mCS = this.rc.getCorrelationSets()
								.getCorrelationSetOnName(set);
						csOut.add(mCS);
					} else {
						Metaset mCS = this.rc.getCorrelationSets()
								.getCorrelationSetOnName(set);
						csOut.add(mCS);
					}
				}
			}
		}
		return csOut;
	}
	
	private Metaset getCSNeed(Metaset mCorrelations) {
		Metaset csNeed = new Metaset("CorrelationSets");
		if (mCorrelations != null) {
			for (int i = 0; i < mCorrelations.getChilds().size(); i++) {
				Metaset mCorrelationSet = (Metaset) mCorrelations.getChilds()
						.get(i);
				String set = mCorrelationSet.selector(".\\", "set");
				String pattern = mCorrelationSet.selector(".\\", "pattern");
				if (pattern.equals("in") || pattern.equals("out-in")) {
					Metaset mCS = this.rc.getCorrelationSets()
							.getCorrelationSetOnName(set);
					csNeed.add(mCS);
				}
			}
		}
		return csNeed;
	}
	
	public Metaset receive(Metaset csNeed, String partnerLink, String portType,
			String operation) {
		String message = this.getMessage(partnerLink, portType, operation);
		while (true) {
						synchronized (this.msgIn) {
				for (int i = 0; i < this.msgIn.size(); i++) {
					IMessageContext messageContext = (IMessageContext) this.msgIn
							.get(i);
					Metaset requestMessage = messageContext
							.getRequestServices();
					
					
					String requestOP = requestMessage.filter(".\\Body\\*")
							.car().getName();
					if (requestOP.equals(message)) {
												Metaset csIn = new Metaset();
						if ((requestMessage
								.filter(".\\Header\\CorrelationSets")) != null) {
							csIn = requestMessage.filter(
									".\\Header\\CorrelationSets").car();
						}
						if (this.isCorrelationSetAccord(csIn, csNeed)) {
							try {
								log.info(sm.getString(
										"org.act.wswf.activity.invoke.receive",
										operation, requestOP));
								this.msgIn.remove(i);
								this.msgIn.notifyAll();
								return (Metaset) requestMessage.clone();
							} catch (CloneNotSupportedException e) {
								e.printStackTrace();
							}
						}
					}
				}
				try {
					this.msgIn.wait();
				} catch (InterruptedException e) {
										e.printStackTrace();
				}
			}
		}
	}
	
	private boolean isCorrelationSetAccord(Metaset remote, Metaset local) {
		if ((remote.isEmpty()) && (local.isEmpty())) {
			return true;
		}
		if ((!remote.isEmpty()) && (!local.isEmpty())) {
			if (local.toXML().equals(remote.toXML())) {
				return true;
			}
		}
		return false;
	}
	
	private void doResult(Metaset result, String outputVariable,
			Metaset mCorrelations) {
		if (result != null) {
			if (!outputVariable.equals("")) {
				for (int i = 0; i < result.getChilds().size(); i++) {
					this.rc.getVariables().setVarPartValue(outputVariable, i,
							((Metaset) result.getChilds().get(i)).getValue());
				}
			}
						if (mCorrelations != null) {
				for (int i = 0; i < mCorrelations.getChilds().size(); i++) {
					Metaset correlationSetIn = (Metaset) mCorrelations
							.getChilds().get(i);
					String pattern = correlationSetIn
							.selector(".\\", "pattern");
					if (!pattern.equals("out-in")) {
						String set = correlationSetIn.selector(".\\", "set");
						String initiate = correlationSetIn.selector(".\\",
								"initiate");
						if (initiate != null && initiate.equals("yes")) {
							this.rc.getCorrelationSets()
									.setCorrelationSetFromVar(set,
											outputVariable);
						}
					}
				}
			}
		}
	}
	
	private Metaset getWSDL(String partnerLink) {
				Metaset mPartnerLink = this.rc.getWc().getPartnerLinks().filter(
				".\\partnerLink", "name", partnerLink);
				String mPartnerRole = mPartnerLink.selector(".\\partnerLink",
				"partnerRole");
				String mPartnerLinkType = mPartnerLink.selector(".\\partnerLink",
				"partnerLinkType");
		QName qname = new QName(mPartnerLinkType);
		String partnerLinkTypeName = qname.getName();
				Metaset wsdl = null;
		try {
			wsdl = (Metaset) this.rc.getWc().getWsdlOnPartnerLinkType(
					partnerLinkTypeName, mPartnerRole);
		} catch (Exception e) {
						e.printStackTrace();
		}
		return wsdl;
	}
	
	private Metaset getTranContext() {
				String transactionName = activity.selector(".\\", "transactionName");
		Metaset tranContextServicesSet = new Metaset();
				if (transactionName != null) {
									Context tranContext = this.rc.getTxContext(transactionName);
						tranContextServicesSet = tranContext.toServiceSet();
			String transactionId = (String) this.rc.getAgent().getTxNameId(
					transactionName);
			this.war.setTransactionId(transactionId);
		}
		return tranContextServicesSet;
	}
	
	private String getMessage(String partnerLink, String portType,
			String operation) {
		Metaset wsdl = this.getWSDL(partnerLink);
		QName qname = new QName(portType);
		String mPortTypeName = qname.getName();
		Metaset mPortType = wsdl.filter(".\\portType", "name", mPortTypeName)
				.car();
		Metaset mOperation = mPortType
				.filter(".\\operation", "name", operation).car();
		String mMessage = mOperation.selector(".\\output", "message");
		qname = new QName(mMessage);
		String mMessageName = qname.getName();
		return mMessageName;
	}
	
	private String getURL(String partnerLink) {
		Metaset wsdl = this.getWSDL(partnerLink);
		String url = wsdl.selector(".\\service\\port\\address", "location");
		return url;
	}
	
	public InvokeImpl(Metaset activity, WorkflowRuntimeContext rc, Stack stack,
			IObjectPool msgIn, IRuntime runtime) {
		super(activity, rc, stack);
		this.msgIn = msgIn;
		this.runtime = runtime;
			}
}
