
package org.act.services.workflow.activity.basic;
import java.util.Stack;
import org.act.metaset.Metaset;
import org.act.services.IMessageContext;
import org.act.services.pool.IObjectPool;
import org.act.services.workflow.activity.ActivityImpl;
import org.act.services.workflow.context.WorkflowRuntimeContext;

public class ReceiveImpl extends ActivityImpl {
	private IObjectPool msgIn;
									public void process() {
				super.process();
		this.startProcess();
		
		String partnerLink = activity.selector(".\\", "partnerLink");
		String portType = activity.selector(".\\", "portType");
		String operation = activity.selector(".\\", "operation");
		String variable = activity.selector(".\\", "variable");
		String createInstance = activity.selector(".\\", "createInstance");
		Metaset mCorrelations = activity.filter(".\\correlations\\*");
		
		System.out.println("partnerLink: "+partnerLink+"  portType: "+portType);
		System.out.println("operation: "+operation+"  variable: "+variable);
		System.out.println("createInstance: "+createInstance);
		
		if (mCorrelations != null) {
			for (int i = 0; i < mCorrelations.getChilds().size(); i++) {
				Metaset mCorrelationSet = (Metaset) mCorrelations.getChilds()
						.get(i);
				
				String set = mCorrelationSet.selector(".\\","set");
				String initiate = mCorrelationSet.selector(".\\", "initiate");
				
				System.out.println("correlation  set: "+set+"  initiate: "+initiate);
			}
		}
	
		Metaset mResult = this.receive(partnerLink,operation,mCorrelations).filter(".\\Body\\*").car();
		
		this.doResult(mResult,variable,mCorrelations);
		
		this.endProcess();
	}
	
	public Metaset receive(String partnerLink,String operation,Metaset mCorrelations) {
		Metaset csNeed = this.getCSNeed(mCorrelations);
		while (true) {
						synchronized (this.msgIn) {
				for (int i = 0; i < this.msgIn.size(); i++) {
					IMessageContext messageContext = (IMessageContext) this.msgIn
							.get(i);
					Metaset requestMessage = messageContext
							.getRequestServices();
					Metaset value = requestMessage.filter(".\\Body\\*");
					if (messageContext.getServicesName().equals(
							rc.getWc().getName())) {
												Metaset csIn = new Metaset();
						if ((requestMessage
								.filter(".\\Header\\CorrelationSets")) != null) {
							csIn = requestMessage
									.filter(
											".\\Header\\CorrelationSets\\correlationSet")
									.car();
						}
						String requestOP = value.car().getName();
						if (requestOP.equals(operation)
								&& this.isCorrelationSetAccord(csIn, csNeed)) {
							try {
								rc.getPartnerLinkMgCxtMap().put(partnerLink,
										messageContext);
								this.msgIn.remove(i);
								return (Metaset) requestMessage.clone();
							} catch (CloneNotSupportedException e) {
								e.printStackTrace();
							}
						}
					}
				}
				try {
					this.msgIn.wait();
				} catch (InterruptedException e) {
										e.printStackTrace();
				}
			}
		}
	}
	
	private Metaset getCSNeed(Metaset mCorrelations) {
		Metaset csNeed = new Metaset();
		if (mCorrelations != null) {
			for (int i = 0; i < mCorrelations.getChilds().size(); i++) {
				Metaset mCorrelationSet = (Metaset) mCorrelations.getChilds()
						.get(i);
				String correlationSetName = mCorrelationSet.selector(".\\",
						"set");
				String initiate = mCorrelationSet.selector(".\\", "initiate");
				
				if ((initiate == null) || (initiate.equals("no"))) {
					Metaset correlationSet = this.rc.getCorrelationSets()
							.getCorrelationSetOnName(correlationSetName);
					csNeed.add(correlationSet);
				}
			}
		}
		return csNeed;
	}
	
	private boolean isCorrelationSetAccord(Metaset remote, Metaset local) {
		if ((remote.isEmpty()) && (local.isEmpty())) {
			return true;
		}
		if ((!remote.isEmpty()) && (!local.isEmpty())) {
			if (local.toXML().equals(remote.toXML())) {
				return true;
			}
		}
		return false;
	}
	
	
	private void doResult(Metaset result,String variable,Metaset mCorrelations) {
		
		for (int i = 0; i < result.getChilds().size(); i++) {
			this.rc.getVariables().setVarPartValue(variable, i,
					((Metaset) result.getChilds().get(i)).getValue());
		}
		if (mCorrelations != null) {
						for (int i = 0; i < mCorrelations.getChilds().size(); i++) {
				Metaset mCorrelationSet = (Metaset) mCorrelations.getChilds()
						.get(i);
				String correlationSetName = mCorrelationSet.selector(".\\",
						"set");
				String initiate = mCorrelationSet.selector(".\\", "initiate");
				if (initiate != null && initiate.equals("yes")) {
					this.rc.getCorrelationSets().setCorrelationSetFromVar(
							correlationSetName, variable);
				}
			}
		}
	}
	
	public ReceiveImpl(Metaset activity, WorkflowRuntimeContext rc,
			Stack stack, IObjectPool msgIn) {
		super(activity, rc, stack);
		this.msgIn = msgIn;
			}
}
