
package org.act.services.workflow.activity.extension;
import java.util.Stack;
import org.act.services.transaction.client.UserTransaction;
import org.act.services.workflow.activity.ActivityImpl;
import org.act.services.workflow.context.WorkflowRuntimeContext;
import org.act.services.workflow.transaction.TransactionAgent;
import org.act.metaset.*;
;

public class BusinessTransactionImpl extends ActivityImpl {
		String transactionName = null;
		String action = null;
		String coordinator = null;
		String outputVariableName = null;
		String txid = null;
		TransactionAgent agent = new TransactionAgent();
	public BusinessTransactionImpl(Metaset activity, WorkflowRuntimeContext rc,
			Stack stack) {
		super(activity, rc, stack);
			}
	public void process() {
				super.process();
		
		transactionName = this.activity.selector(".\\", "transactionName");
		action = this.activity.selector(".\\", "action");
		coordinator = this.activity.selector(".\\", "coordinator");
		outputVariableName = this.activity.selector(".\\", "outputVariable");
				Metaset varTemp = this.rc.getVariables().getVariables();
		this.invokeCoordinator(varTemp);
	}
	private void invokeCoordinator(Metaset varTemp) {
		try {
						UserTransaction ut;
						if (action != null) {
				ut = UserTransaction.newInstance();
				if (action.equals("begin")) {
										
										ut.beginAtom();
										this.agent = this.rc.getAgent();
					this.txid = ut.getTransactionId();
										agent.RegistTxNameId(transactionName, txid);
										agent.registerUserTransaction(this.txid, ut);
					this.rc.setAgent(agent);
				} else if (action.equals("confirm")) {
										this.agent = this.rc.getAgent();
										this.txid = (String) agent.getTxNameId(transactionName);
										ut = (UserTransaction) agent
							.unRegisterUserTransaction(this.txid);
					this.rc.setAgent(agent);
					try {
						boolean ret;
												ret = ut.confirmAtomTransaction();
												if (ret)
							this.rc.getVariables().setVarPartValue(
									outputVariableName, 0, "true");
						else {
							this.rc.getVariables().setVarPartValue(
									outputVariableName, 0, "false");
							this.rc.getVariables().setVars(varTemp);
						}
					} catch (Exception ex) {
						ex.printStackTrace();
					}
				}
			}
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
}
