
package org.act.services.workflow.context;
import java.util.HashMap;
import java.util.Map;

public class WorkflowContextPoolImpl implements IWorkflowContextPool {
	private Map map = new HashMap();
	
	public WorkflowContext getWorkflowContext(String name) {
		synchronized (map) {
			return (WorkflowContext) map.get(name);
		}
	}
	public WorkflowContext[] getWorkflowContext() {
		synchronized (map) {
			return (WorkflowContext[]) map.values().toArray(
					new WorkflowContext[0]);
		}
	}
	
	public void put(WorkflowContext context) {
		synchronized (map) {
			map.put(context.getName(), context);
		}
	}
	
	public void remove(String name) {
		synchronized (map) {
			map.remove(name);
		}
	}
}
