
package org.act.services.workflow.debug;
import java.util.List;
import java.util.Stack;
import java.util.Vector;
import org.act.metaset.Attribute;
import org.act.metaset.Metaset;
import org.act.services.workflow.context.WorkflowRuntimeContext;
import org.act.services.workflow.data.Variable;

public class Debug {
	private static boolean debug = false;
	private static List idList = null;
	private static WorkflowRuntimeContext rc = null;
	private static List listeners = new Vector();
	private static String debugPath = null;
	
	public static void clean() {
		debug = false;
		idList = null;
		rc = null;
	}
	
	public static boolean inIdList(String id) {
		if (idList == null) {
			return false;
		} else {
			for (int i = 0; i < idList.size(); i++) {
				if (id.equals((String) idList.get(i))) {
					return true;
				}
			}
			return false;
		}
	}
	
	public static void restart(List idList) {
		setIdList(idList);
		synchronized (rc) {
			rc.notifyAll();
		}
	}
	
	public static void setVarPartValue(String varName, String partName,
			String value) {
		rc.getVariables().setVarPartValue(varName, partName, value);
	}
	
	public static String getVarPartValue(String varName, String partName) {
		return rc.getVariables().getVarPartValue(varName, partName);
	}
	
								public static Metaset getVars() {
		Metaset vars = rc.getVariables().getVariables();
		Stack localKeepStack = rc.getLocalKeepStack();
		for (int i = localKeepStack.size() - 2; i > 0; i = i - 6) {
			Variable variable = (Variable) localKeepStack.get(i);
			Metaset tempVars = variable.getVariables();
			if (tempVars != null) {
				for (int j = 0; j < tempVars.getChilds().size(); j++) {
					vars.add((Metaset) tempVars.getChilds().get(j));
				}
			}
		}
		return vars;
	}
	
	public static boolean setDebug(String id) {
		Stack stack = rc.getActivitiesStack();
		return setDebug(stack, id);
	}
	
	public static boolean setDebug(List list, String id) {
		if (list != null) {
			for (int i = 0; i < list.size(); i++) {
				Metaset activity = (Metaset) list.get(i);
				String debugId = activity.selector(".\\", "debugId");
				if (debugId != null && debugId.equals(id)) {
					for (int j = 0; j < activity.getAttributes().size(); j++) {
						Attribute attr = (Attribute) activity.getAttributes()
								.get(j);
						if (attr.getName().equals("breakPoint")) {
							if (attr.getValue().equals("false")) {
								attr.setValue("true");
							} else {
								attr.setValue("false");
							}
							return true;
						}
					}
				}
				if (setDebug(activity.getChilds(), id)) {
					return true;
				}
			}
		}
		return false;
	}
	
	public static boolean inStack(String id) {
		Stack stack = rc.getActivitiesStack();
		return inStack(stack, id);
	}
	
	public static boolean inStack(List list, String id) {
		if (list != null) {
			for (int i = 0; i < list.size(); i++) {
				Metaset activity = (Metaset) list.get(i);
				String debugId = activity.selector(".\\", "debugId");
				if (debugId != null && debugId.equals(id)) {
					return true;
				}
				if (inStack(activity.getChilds(), id)) {
					return true;
				}
			}	
		}
		return false;
	}
	
	public static void replace(Metaset activity, String id) {
		try {
			Metaset repActivity = (Metaset) activity.clone();
			Stack stack = rc.getActivitiesStack();
			replace(stack, repActivity, id);
		} catch (CloneNotSupportedException e) {
						e.printStackTrace();
		}
	}
	
	public static void replace(List list, Metaset activity, String id) {
		for (int i = 0; i < list.size(); i++) {
			Metaset orgActivity = (Metaset) list.get(i);
			String debugId = orgActivity.selector(".\\", "debugId");
			if (debugId != null && debugId.equals(id)) {
				list.remove(i);
				list.add(i, activity);
				activity.setFather(orgActivity.getFather());
				return;
			} else {
				if (orgActivity.getChilds() != null) {
					replace(orgActivity.getChilds(), activity, id);
				}
			}
		}
	}
	
	public static WorkflowRuntimeContext getRc() {
		return rc;
	}
	
	public static void setRc(WorkflowRuntimeContext rc) {
		Debug.rc = rc;
	}
	
	public static boolean isDebug() {
		return debug;
	}
	
	public static void setDebug(boolean debug) {
		Debug.debug = debug;
	}
	
	public static List getIdList() {
		return idList;
	}
	
	public static void setIdList(List idList) {
		Debug.idList = idList;
	}
	
	public static List getListeners() {
		return listeners;
	}
	
	public static void setListeners(List listeners) {
		Debug.listeners = listeners;
	}
	
	public static String getDebugPath() {
		return debugPath;
	}
	
	public static void setDebugPath(String debugPath) {
		Debug.debugPath = debugPath;
	}
}
