
package org.act.services.workflow.expression;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import org.act.metaset.Metaset;
import org.act.services.workflow.context.WorkflowRuntimeContext;
import org.apache.xpath.XPathAPI;
import org.apache.xpath.objects.XObject;
import org.w3c.dom.Document;

public class BooleanExpression {
	
	public static boolean getExpressionValue(String expression,
			WorkflowRuntimeContext rc) throws Exception {
		int pos = expression.indexOf("bpws:getVariableData");
		while (pos != -1) {
			expression = replace(expression, "bpws:getVariableData", rc);
			pos = expression.indexOf("bpws:getVariableData");
		}
		Document doc = newDocument();
		XObject xobject = XPathAPI.eval(doc, expression);
		return xobject.bool();
	}
	
	private static String replace(String originalStr, String replaceStr,
			WorkflowRuntimeContext rc) {
		int pos;
		pos = originalStr.indexOf(replaceStr);
		String save = null;
		if (pos != -1) {
									save = originalStr.substring(0, pos);
			originalStr = originalStr.substring(pos);
						pos = originalStr.indexOf('\'');
			String temp = originalStr.substring(pos + 1);
			pos = temp.indexOf('\'');
			String variableName = temp.substring(0, pos);
			temp = temp.substring(pos + 1);
			pos = temp.indexOf('\'');
			temp = temp.substring(pos + 1);
			pos = temp.indexOf('\'');
			String partName = temp.substring(0, pos);
			pos = temp.indexOf(')');
						temp = temp.substring(pos + 1);
			Metaset variable = rc.getVariables().getVar(variableName);
			Metaset part = variable.filter(".\\part", "name", partName)
					.car();
			String type = part.selector(".\\", "type");
			String value = part.getValue();
			if (type.equals("xsd:int") || type.equals("xsd:boolean")) {
				save = save + value + temp;
			} else {
				save = save + "'" + value + "'" + temp;
			}
		} else {
			save = originalStr;
		}
		return save;
	}
	
	private static DocumentBuilder newBuilder(boolean validation)
			throws Exception {
		DocumentBuilderFactory domFactory = DocumentBuilderFactory
				.newInstance();
		domFactory.setValidating(validation);
		domFactory.setNamespaceAware(true);
		DocumentBuilder domBuilder = domFactory.newDocumentBuilder();
		return domBuilder;
	}
	
	private static Document newDocument() throws Exception {
		DocumentBuilder domBuilder = newBuilder(false);
		Document document = domBuilder.newDocument();
		return document;
	}
}
