
package org.act.services.workflow.manager;
import java.lang.reflect.Method;
import org.act.metaset.Metaset;
import org.act.services.IMessageContext;
import org.act.services.pool.IObjectPool;
import org.act.services.runtime.Application;
import org.act.services.runtime.IRuntime;
import org.act.services.thread.ObjectOperationException;
import org.act.services.thread.Terminatable;
import org.act.services.workflow.management.SystemInfoWrapper;

public class WorkflowEngineManager extends Terminatable {
						
	public WorkflowEngineManager(IObjectPool msgInputPool,
			IObjectPool msgOutputPool, IRuntime runtime) {
				this.msgIn = msgInputPool;
		this.runtime = runtime;
	}
	private IObjectPool msgIn = null;
	private IRuntime runtime = null;
	
	protected void process() throws ObjectOperationException {
						synchronized (msgIn) {
			while (msgIn.size() != 0) {
				IMessageContext context = (IMessageContext) msgIn.get();
								Metaset requestService = context.getRequestServices();
				String methodName = getMethod(requestService);
				if (Application.isDebug()) {
					System.out.println("manage:" + methodName);
				}
				try {
					Class c = Class
							.forName("org.act.services.workflow.management.SystemInfoWrapper");
					SystemInfoWrapper a = new SystemInfoWrapper();
					Method method;
					try {
						method = c.getMethod(methodName,
								new Class[] { Metaset.class });
						Metaset msg = (Metaset) method.invoke(a,
								new Object[] { requestService });
						context.setResponseServices(msg);
					} catch (Exception e) {
						method = c.getMethod(methodName,
								new Class[] { IMessageContext.class });
						method.invoke(a, new Object[] { context });
					}
					IObjectPool msgOutputPool = this.runtime.getObjectPool(
							"message", IObjectPool.OUT_MODE);
					synchronized (msgOutputPool) {
						msgOutputPool.put(context);
						msgOutputPool.notifyAll();
					}
				} catch (Exception e) {
										e.printStackTrace();
				}
			}
						try {
				msgIn.wait();
			} catch (InterruptedException e) {
				e.printStackTrace();
			}
		}
	}
	public String getMethod(Metaset set) {
						Metaset childElements = set.filter(".\\Body\\*");
		if (!childElements.isEmpty()) {
			Metaset firstChildElement = childElements.car();
			String name = firstChildElement.getName();
			return name;
		}
		return null;
	}
}
